#!/bin/bash -l


function switch_to_java() {
  local java_version=$1

  case "${java_version}" in
    21)
      switch_to java "zulu-${java_version}"
      ;;
    *)
      switch_to java "adoptopenjdk-${java_version}"
      ;;
  esac
}

# switch_to switches to a given tool and version
# Example: switch_to 'java' '11'
#
# The above command will switch to the adopt-openjdk-11.0.7+10 version of java
function switch_to() {
  local tool=$1
  local given_version=$2
  local tool_versions
  local selected_version

  # fetch line matching tool, ignore the first word and use 'read' to turn space-delimited words into an array
  IFS=" " read -r -a tool_versions <<<"$(grep "$tool" "$HOME/.tool-versions" | cut -d ' ' -f2-)"

  # if no match is found, default to first entry in .tool-versions file
  default_version=${tool_versions[0]}

  for tool_version in "${tool_versions[@]}"; do
    if [[ $tool_version = $given_version* ]]; then
      selected_version=$tool_version
      break
    fi
  done

  # no match found
  if [[ -z ${selected_version:-} ]]; then
    echo "Unable to find ${tool} version '${given_version}', defaulting to version '${default_version}'"
    selected_version=$default_version
  fi

  echo "Using ${tool} version '${selected_version}'"
  asdf shell "$tool" "$selected_version"
  _asdf_java_update_java_home
}

# shellcheck source=/dev/null
. "$ASDF_DATA_DIR/asdf.sh"
# shellcheck source=/dev/null
. "$ASDF_DATA_DIR/completions/asdf.bash"
# shellcheck source=/dev/null
. "$ASDF_DATA_DIR"/plugins/java/set-java-home.bash
